# DevSecOps 2022 - Инструкция по подготовке к программе. Что нужно установить до начала тренингов, что мы будем изучать



## Цель обучения

Освоить современные практики непрерывной интеграции и доставки нового кода (Continuous Integration / Continuous Delivery, CI/CD) на примере технологий GitLab/GitFlow и Docker. Участники разберутся с принципами CI/CD, научатся создавать пайплайны на примере Gitlab CI, освоят методы и инструменты контейнеризации на примере Docker, научатся строить цепочку поставки, включающую все основные стадии - сборка, тестирование, упаковка, сканирование.

## Темы

В рамках обучения мы рассматриваем следующие темы:

- [ ] Введение в DevOps/DevSecOps
- [ ] Инструменты совместной работы
- [ ] Технологии контейнеризации
- [ ] Обеспечение безопасности контейнеров
- [ ] Автоматизация цепочки поставки
- [ ] Безопасность рабочей нагрузки
- [ ] Технологии оркестрации (самостоятельная работа)

## Программа
Посмотреть расписание [можно здесь](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%9F%D1%80%D0%BE%D0%B3%D1%80%D0%B0%D0%BC%D0%BC%D0%B0_%D0%94%D0%9F%D0%9E_DevSecOps_2022.pdf)


| Дата       | Время         | Трансляция                                                                | Материалы                                                                                                                                                                                                                                                                                                                                                                                                                             | Задание                                                                                                                                                                           | Тренер         | Баллы | Блокирующий |
|------------|---------------|---------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|----------------|-------|-------------|
| 28.11.2022 | 18.00 – 20.00 | [Введение в DevOps/DevSecOps](https://youtu.be/dymhg6d1XYc)               | [Презентация](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%B4%D0%B5%D0%BD%D1%8C1%D0%B2%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5.pdf)<br/>см. так же раздел [Настройка docker runner](https://git.miem.hse.ru/vbashun/devsecops2022/#%D0%BD%D0%B0%D1%81%D1%82%D1%80%D0%BE%D0%B9%D0%BA%D0%B0-docker-runner)<br/>ответ на задание загружаем в [форму](https://forms.yandex.ru/cloud/6384f666f47e730620b8b8ee/) | [Задание 1](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%B4%D0%B5%D0%BD%D1%8C1%D0%B7%D0%B0%D0%B4%D0%B0%D0%BD%D0%B8%D0%B51.pdf)<br/>30 ноября (23:59 МСК) | Башун В.В.     | 2     | да          |
| 29.11.2022 | 18.00 – 20.00 | [Технологии контейнеризации](https://youtu.be/YE_ZoRaz9dk)                | [Презентация](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%B4%D0%B5%D0%BD%D1%8C2%D0%BB%D0%B5%D0%BA%D1%86%D0%B8%D1%8F_%D0%BA%D0%BE%D0%BD%D1%82%D0%B5%D0%B9%D0%BD%D0%B5%D1%80%D1%8B1.pdf)                                                                                                                                                                                                                      | [Задание 2](https://forms.yandex.ru/u/6383977c90fa7bcea87eeee1/)<br/>1 декабря (23:59 МСК)                                                                                        | Курмашева Т.А. | 3     | да          |
| 30.11.2022 | 16.00 – 18.00 | [Обеспечение безопасности контейнеров](https://youtu.be/uvV0dxBFJk4)      | [Презентация](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%B4%D0%B5%D0%BD%D1%8C3%D1%82%D0%B5%D0%BC%D0%B01sast.pdf)                                                                                                                                                                                                                                                                                           | [Задание 3](https://forms.yandex.ru/u/6387964a73cee75693016312/)<br/>2 декабря (23:59 МСК)                                                                                        | Курмашева Т.А. | 3     | нет         |
| 30.11.2022 | 18.30 – 20.00 | [Автоматизация цепочки поставки. Gitlab CI](https://youtu.be/RS-9rsvBnWg) | [Презентация](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%B4%D0%B5%D0%BD%D1%8C3_%D1%82%D0%B5%D0%BC%D0%B02_ci_cd.pdf)<br/>[Конспект](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/%D0%B4%D0%B5%D0%BD%D1%8C3_%D1%82%D0%B5%D0%BC%D0%B02_%D0%BA%D0%BE%D0%BD%D1%81%D0%BF%D0%B5%D0%BA%D1%82_ci_cd_.pdf)<br/>[Доп. материал](https://youtu.be/SiR4XXx1aXQ?t=7402)                             | [Задание 4](https://forms.yandex.ru/u/63862836e010db21acd4d6dc/)<br/>2 декабря (11:59 МСК)                                                                                        | Завьялова А.Д. | 3     | да          |
| 01.11.2022 | 18.30 – 20.30 | [Безопасность рабочей нагрузки](https://youtu.be/ECEpI4CWjuo)             |                                                                                                                                                                                                                                                                                                                                                                                                                                       | Задание 5                                                                                                                                                                         | Курмашева Т.А. | 3     | нет         |
| 02.11.2022 | 18.00 – 20.00 | [Автоматизация цепочки поставки. Ansible](https://youtu.be/BQev1OTBR8Y)   |                                                                                                                                                                                                                                                                                                                                                                                                                                       | Задание 6                                                                                                                                                                         | Завьялова А.Д. | 3     | нет         |
| 03.11.2022 | 10.00 – 14.00 | Тест                                                                      |                                                                                                                                                                                                                                                                                                                                                                                                                                       |                                                                                                                                                                                   |                | 3     | да          |

Пры выполнении заданий не забывайте пользоваться так же [справочными материалами](https://git.miem.hse.ru/vbashun/devsecops2022/#%D0%BF%D0%BE%D0%BB%D0%B5%D0%B7%D0%BD%D1%8B%D0%B5-%D1%81%D1%81%D1%8B%D0%BB%D0%BA%D0%B8-%D0%B8-%D0%B4%D0%BE%D0%BA%D1%83%D0%BC%D0%B5%D0%BD%D1%82%D0%B0%D1%86%D0%B8%D1%8F)



## Требования к участникам
- [ ] Участники должны не бояться работать с командной строкой.
- [ ] Знать основы Linux (базовое администрирование). 
- [ ] Базовые навыки программирования.
- [ ] Базовые знания компьютерных сетей. 
- [ ] Базовые навыки работы с git.

Инструменты совместной работы (git) является одной из тем, которые мы рассматриваем, но предполагается, что вы знаете основы работы с git.
Некоторые базовые вещи [разбираются в этом видео](https://youtu.be/U0yPHH72l1k) 
Пожалуйста, ознакомьтесь с ним заранее, если у вас нет опыта работы с git.

## (ВАЖНО) Необходимые действия до начала обучения 

1. Вам необходимо зарегистрироваться на платформе [GitLab (DevSecOps platform)](https://gitlab.com/)
    - [ ] Все задания, требующие использования репозитория и запуска CI/CD пайплайнов, будет делать на этой платформе.

2. Вам необходимо зарегистрироваться на  [Docker Hub](https://hub.docker.com/)
    - [ ] Сюда мы будет загружать полученные образы контейнеров.

3. Вам необходимо подготовить компьютер, установив на него [необходимое ПО](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/README.md#%D0%BD%D0%B5%D0%BE%D0%B1%D1%85%D0%BE%D0%B4%D0%B8%D0%BC%D0%BE%D0%B5-%D0%BF%D0%BE)
    - [ ] Без его установки, вы не сможете выполнять задания.

## Необходимое ПО 

Для выполнения практических заданий вам понадобится:

- [ ] Клиент git

    - Установка git client
        - https://git-scm.com/book/ru/v2/%D0%92%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5-%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0-Git 
        - https://git-scm.com/book/en/v2/Getting-Started-Installing-Git 
        - https://git-scm.com/download/win 

    - Много полезной информации по работе с git
        - https://git-scm.com/book/ru/v2/

- [ ] Docker (или другое CRI-совместимое решение). 

Мы рекомендуем использовать docker под ОС Linux (если у вас другая ОС, можно развернуть ее, например, в virtual box).

    - Документация по установке docker:
        - https://docs.docker.com/engine/install/

    - Если вы будете работать с docker под Windows
        - https://docs.docker.com/desktop/install/windows-install/ 
        - https://learn.microsoft.com/ru-ru/virtualization/windowscontainers/quick-start/set-up-environment?tabs=Windows-Server

- [ ] Рекомендуем Вам установить Python3 и среду разработки к нему для выполнения домашних заданий. 
    - Если Вы планируете использовать другой язык -- предустановите его


### Настройка docker runner

- Порядок действий
  - Создаем новую группу в гитлабе
  - Переходим в CI/CD настройки группы
  - По [инструкции](https://docs.gitlab.com/runner/install/docker.html#install-the-docker-image-and-start-the-container) устанавливаем ранер на свой компьютер
  - [Регистрируем](https://docs.gitlab.com/runner/register/index.html#docker) свой раннер для группы  ([скрин](https://git.miem.hse.ru/vbashun/devsecops2022/-/blob/master/files/install_and_register_runner.png))
  - В настройках ранера CI/CD => Runners => Редактировать  поставьте галочку «Run unstaged jobs»
  - В настройках Settings => CI/CD => Runners необходимо выключить "Enable shared runners for this group"

- Ссылки на документацию
  - [Run GitLab Runner in a container](https://docs.gitlab.com/runner/install/docker.html)
  - [Регистрация раннера](https://docs.gitlab.com/runner/register/index.html#docker)

- Настройка раннера

Подробнее в [официальной документации](https://docs.gitlab.com/runner/install/docker.html#install-the-docker-image-and-start-the-container) 

    - docker volume create gitlab-runner-config

    - docker run -d --name gitlab-runner --restart always \
        -v /var/run/docker.sock:/var/run/docker.sock \
        -v gitlab-runner-config:/etc/gitlab-runner \
        gitlab/gitlab-runner:latest

    - docker run --rm -it -v gitlab-runner-config:/etc/gitlab-runner  gitlab/gitlab-runner:latest register



под Windows если вы пользуетесь git bash консолью, указывайте корректно пути для mount (см. пример)

    - winpty docker run --rm -it -v //d/projects/runner2/gitlab-runner/config:/etc/gitlab-runner  \
        -v //d/projects/runner2/var/run/docker.sock:/var/run/docker.sock   gitlab/gitlab-runner:latest status

    - winpty docker run --rm -it -v //d/projects/runner2/gitlab-runner/config:/etc/gitlab-runner  \
        -v //d/projects/runner2/var/run/docker.sock:/var/run/docker.sock   gitlab/gitlab-runner:latest register


### Для самостоятельного изучения темы оркестраторы

Так же для выполнения самостоятельной работы по оркестраторам вам понадобится (***вы можете сделать это позднее**, материалы для самостоятельного изучения будут доступны и после завершения обучения)

- Minikube и одним из драйверов на выбор (Docker, Hyperkit, Hyper-V, KVM, Parallels, Podman, VirtualBox, or VMware Fusion/Workstation). Рекомендуется VirtualBox или VMware
    - https://minikube.sigs.k8s.io/docs/start/ 

### Полезные ссылки и документация

- Тема Git
  - [Книга по Git. Много информации](https://git-scm.com/book/ru/v2/)
  - [Установка Git](https://git-scm.com/book/ru/v2/%D0%92%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5-%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0-Git)

- Тема Gitlab
  - [Run GitLab Runner in a container](https://docs.gitlab.com/runner/install/docker.html)
  - [Регистрация раннера](https://docs.gitlab.com/runner/register/index.html#docker)
- Тема Docker
  - [Основная документация Docker](https://docs.docker.com/)
  - [Установка Docker](https://docs.docker.com/engine/install/)
  - [Docker getting started](https://docs.docker.com/get-started/)
  - [Справка по написанию Dockerfile](https://docs.docker.com/engine/reference/builder/)
  - [Запуск команды в контейнере](https://docs.docker.com/engine/reference/commandline/run/)
- Тема "Безопасность контейнеров"
  - [Docker Security Cheat Sheet](https://cheatsheetseries.owasp.org/cheatsheets/Docker_Security_Cheat_Sheet.html)
  - [Базовые образы RedHat](https://catalog.redhat.com/software/containers/search)
  - [Container Security Checklist](https://github.com/krol3/container-security-checklist )
  - [OWASP Top 10](https://owasp.org/www-project-top-ten/)
  - [CVSS Score](https://www.first.org/cvss/calculator/3.1)
  - [Trivy](https://github.com/aquasecurity/trivy)
  - [Trivy installation](https://aquasecurity.github.io/trivy/v0.35/getting-started/installation/)
- Прочее
  - [Утановка Ubuntu в VirtualBox](https://ubuntu.com/tutorials/how-to-run-ubuntu-desktop-on-a-virtual-machine-using-virtualbox#1-overview)

